//  $Id: olympus.hh,v 1.5 2004/05/04 15:26:18 adams Exp $
//  Author:             Mark F. Adams
// Copyright (c) 2003 by Mark F. Adams 
//  Filename:           olympus.hh
//
#ifndef  __OLYMPUS_H__
#define  __OLYMPUS_H__

#include "athena.hh"
#include "pfeap.hh"
#include "prometheus.hh"

#if defined(PROM_HAVE_SILO)
#include <silo.h>
#endif

class Prometheus_LinSysCore;

////////////////////////////////////////////////////////////////////////
//! Driver for multi-component FE application
////////////////////////////////////////////////////////////////////////
class Olympus
{
public:
  Olympus(const PromComm &comm, PromOptions &opts, PromPerfMonitor &perf,
	  int argc = 0, char **args = NULL );
  ~Olympus();
  // methods
  int Go();
  //int PostRun();
  int SetUp();
  int SetUpPrometheus();
  int Run();
  int Newton( const int );
  // output
  int InitializeDB( const int nsteps, char *prestr = NULL )const;
  int StepDB( int step, const int nsteps, double time, char *prestr )const;
  int CreateMultiDB(const FEDataClient*const fe,int s,const int nsteps,
		    double t,char *p)const;
#if defined(PROM_HAVE_SILO)
  int CreateDB( DBfile **dbfile_out, int step,  const int nsteps,
		double time, char *prestr ) const;
  int PutMesh(DBfile*, const FEDataClient *const, int, double)const;
#endif
  int FinalizeDB( int nsteps, double dt, char *prestr=NULL )const;
  // data
  Prometheus_LinSysCore *linSys_;
  AthenaFeap       *athena_;
  pFEAP            *pfeap_;
  // standard data
  const PromComm   &Comm_; 
  PromOptions      &options_;
  PromPerfMonitor  &perf_mon_;
};

#endif // __OLYMPUS_H__
